import { createAsyncThunk, createSlice, PayloadAction } from '@reduxjs/toolkit';
import { generateStatus, success } from "../../../utils/ReduxHelper/Generators";
import { LogicError } from "../../../utils/RequestHelper/errorResponse";
import { ID, SliceStateWithPaginationAndDetail } from "../../interfaces/types";
import { RootState } from '../../store/store';
import { mockUserService } from "./MockUserService";

export interface MockUser {
    id: string,
    name: string,
    phone: string,
    email: string,
    text: string,
    list: number[],
    address: string,
}

export type MockUserCreateDto = Omit<MockUser, "id">;

const initialState: SliceStateWithPaginationAndDetail<MockUser,MockUser> = {
    detailedStatus: generateStatus(),
    detailed: undefined,
    limit: 0, page: 0, status: generateStatus(),
    data: []
}

// ? https://redux-toolkit.js.org/usage/usage-with-typescript#createasyncthunk => Typing a thunk
export const addNewUser = createAsyncThunk<MockUser, MockUserCreateDto>(
    'user/addNewUser',
    async (newUser,{rejectWithValue}) => {
        try {
            return await mockUserService.createMockUser(newUser)
        } catch (err) {
            // Use `err.response.data` as `action.payload` for a `rejected` action,
            // by explicitly returning it using the `rejectWithValue()` utility
            // @ts-ignore
            return rejectWithValue(err.response.data)
        }
    }
);

export const getMockUsers = createAsyncThunk<MockUser[]>(
    'user/getMockUsers',
    async () => {
        try {
            return await mockUserService.getMockUsers()
        } catch (err) {
            // Use `err.response.data` as `action.payload` for a `rejected` action,
            // by explicitly returning it using the `rejectWithValue()` utility
            throw new LogicError("Thua")
        }
    }
);

export const getMockUserDetailByID = createAsyncThunk<MockUser,ID>(
    'user/getMockUserDetailByID',
     async (id) => {
        try {
            return await mockUserService.getMockUsersDetail(id)
        } catch (err) {
            throw new LogicError("Thua")
        }
    }
);

// ? Redux reduces can modify state directly (No need to spread object / array if we know key / index)
export const mockUserSlice = createSlice({
    name: 'mockUser',
    initialState,
    // The `reducers` field lets us define reducers and generate associated actions
    // ! The reducer here should Synchronous only and Pure (Local changes / UI update only)
    reducers: {
        changeUserNameByID: (state,action : PayloadAction<{id: string, name: string}>) => {
            // Redux Toolkit allows us to write "mutating" logic in reducers. It
            // doesn't actually mutate the state because it uses the Immer library,
            // which detects changes to a "draft state" and produces a brand new
            // immutable state based off those changes
            const {id, name} = action.payload;
            state.data = state.data.map((item) => {
                return item.id !== id ? item : {...item, name};
            });
        },
        // // Use the PayloadAction type to declare the contents of `action.payload`
        // incrementByAmount: (state, action: PayloadAction<number>) => {
        //     state.value += action.payload;
        // },
    },
    // The `extraReducers` field lets the slice handle actions defined elsewhere,
    // including actions generated by createAsyncThunk or in other slices.
    // ! Reducer handling async logics should be defined here (Call API,...)
    extraReducers: (builder) => {
        // The `builder` callback form is used here because it provides correctly typed reducers from the action creators
        builder.addCase(addNewUser.fulfilled, (state, { payload }) => {
            state.data.push(payload);
        })
        builder.addCase(getMockUsers.fulfilled, (state, { payload }) => {
            state.data = payload;
            state.status = success();
        })
        builder.addCase(getMockUserDetailByID.fulfilled, (state, { payload }) => {
            state.detailed = payload;
            state.detailedStatus = success();
        })
    },
});

export const {changeUserNameByID} = mockUserSlice.actions;

// The function below is called a selector and allows us to select a value from
// the state. Selectors can also be defined inline where they're used instead of
// in the slice file. For example: `useSelector((state: RootState) => state.counter.value)`

export const selectUserList = (state: RootState) => state.mockUser.data;
export const selectUserListLoading = (state: RootState) => state.mockUser.status.isLoading;
export const selectUserListSuccess = (state: RootState) => state.mockUser.status.isSuccess;
export const selectUserListError = (state: RootState) => state.mockUser.status.isError;

export const selectDetailedMockUser = (state: RootState) => state.mockUser.detailed;
export const selectDetailedMockUserState = (state: RootState) => state.mockUser.detailedStatus;



export default mockUserSlice.reducer;